#include <machine.h>
#include "3048fone.h"
#include "ff.h"
#include "diskio.h"
#include "spi.h"
#include "h8_3048fone.h"

/*7̂ǂꂩ1mainLɂmainIĂ*/
/*#define main0*/
/*#define main1*/
/*#define main2*/
/*#define main3*/
/*#define main4*/
/*#define main5*/
#define main6


#define DRIVE_NO 0     /*hCuԍ*/

/*---------------------------------------------------------*/
/* User Provided Timer Function for FatFs module           */
/*---------------------------------------------------------*/
/* This is a real time clock service to be called from     */
/* FatFs module. Any valid time must be returned even if   */
/* the system does not support a real time clock.          */
DWORD get_fattime ()
{
	DWORD tmr=0;


	set_imask_ccr(1);
/*
	tmr =	  (((DWORD)rtcYear - 80) << 25)
			| ((DWORD)rtcMon << 21)
			| ((DWORD)rtcMday << 16)
			| (WORD)(rtcHour << 11)
			| (WORD)(rtcMin << 5)
			| (WORD)(rtcSec >> 1);
*/
	tmr =	  (((DWORD)(2013 - 80)) << 25)
			| ((DWORD)1 << 21)
			| ((DWORD)1 << 16)
			| (WORD)(10 << 11)
			| (WORD)(50 << 5)
			| (WORD)(40 >> 1);

	set_imask_ccr(0);

	return tmr;
}

static void msecwait(int msec)
{
    int i,j;
    for (i=0;i<msec;i++) {
        for (j=0;j<4190;j++);    /*4190͎ɂċ߂l 25MHz쓮*/
    }
}

BYTE buff[512];
char line_buff[80];

FATFS fatfs;     /* File system object */
FIL fp;          /* File object */
DIR dir;         /* Directory object */
FILINFO Finfo;

int showDirectory(char *dirname)
{
	FRESULT fres;
	int nfiles=0,ndirs=0,ndotdir=0;
	DWORD nclusters,totalsize=0;
	FATFS *pfatfs=&fatfs;
	char *pfname;

#if _USE_LFN
	static char lfn[_MAX_LFN + 1];
	Finfo.lfname = lfn;
	Finfo.lfsize = sizeof(lfn);
#endif

	fres=f_getcwd(line_buff,80);
	SCI1_printf("res=%d f_getcwd\n",fres);
	SCI1_printf("current directory name : [%s]\n",line_buff);
	fres=f_opendir(&dir,dirname);
	SCI1_printf("res=%d f_opendir %s\n",fres,dirname);
	SCI1_printf("directory name : [%s]\n",dirname);
	while (((fres = f_readdir(&dir, &Finfo)) == FR_OK) && Finfo.fname[0]) {
		if (Finfo.fattrib & AM_DIR) {
			if (Finfo.fname[0]!='.') ndirs++;
			else ndotdir++;
		} else {
			nfiles++; totalsize += Finfo.fsize;
		}
#if _USE_LFN
		pfname = Finfo.lfname[0] ? Finfo.lfname : Finfo.fname;
#else
		pfname = Finfo.fname;
#endif
		SCI1_printf("%c%c%c%c%c %u/%02u/%02u %02u:%02u %9lu  %s\n", 
				(Finfo.fattrib & AM_DIR) ? 'D' : '-',
				(Finfo.fattrib & AM_RDO) ? 'R' : '-',
				(Finfo.fattrib & AM_HID) ? 'H' : '-',
				(Finfo.fattrib & AM_SYS) ? 'S' : '-',
				(Finfo.fattrib & AM_ARC) ? 'A' : '-',
				(Finfo.fdate >> 9) + 1980, (Finfo.fdate >> 5) & 15, Finfo.fdate & 31,
				(Finfo.ftime >> 11), (Finfo.ftime >> 5) & 63,
				Finfo.fsize, pfname);
	}
	SCI1_printf("%4u File(s),%10lu bytes\n%4u Dir(s)", nfiles, totalsize, ndirs+ndotdir);
	if (f_getfree((TCHAR *)dirname, &nclusters, &pfatfs) == FR_OK) {
		SCI1_printf(", %10luK bytes free", nclusters * fatfs.csize / 2);
	}
	SCI1_printf("\n");
	return nfiles+ndirs;
}

void size_test() /*ǂ炩ĂяoăeXg*/
{
	SCI1_printf("\nsize test\n");
	SCI1_printf("sizeof(FATFS)   = %5d [%05x]\n",(WORD)sizeof(FATFS),(WORD)sizeof(FATFS));
	SCI1_printf("sizeof(FIL)     = %5d [%05x]\n",(WORD)sizeof(FIL),(WORD)sizeof(FIL));
	SCI1_printf("sizeof(DIR)     = %5d [%05x]\n",(WORD)sizeof(DIR),(WORD)sizeof(DIR));
	SCI1_printf("sizeof(FILINFO) = %5d [%05x]\n",(WORD)sizeof(FILINFO),(WORD)sizeof(FILINFO));
	while(1);
/*
size test
sizeof(FATFS)   =   562 [00232]
sizeof(FIL)     =    36 [00024]
sizeof(DIR)     =    34 [00022]
sizeof(FILINFO) =    28 [0001c]
*/
}

#ifdef main6
/*long name*/
void main()
{
	int tick=0;
	int res;
	FRESULT fres;
	const char fname[]="filetest_longname.txt";

	initLed();
	initTimer1Int(10000); /*10msecC^[o^C}荞*/
	startTimer1();
	initSCI1();
	initSPI_CS();
	msecwait(10); /*SD̂߂ɂ1msecȏwaitKv*/
	initSPI(0);    /*[h0iᑬjŏ*/
	initDMAC();
	set_imask_ccr(0);
	
	SCI1_printf("\nlevel 6 long file name\n");
	do {
		res=disk_initialize(DRIVE_NO);
		SCI1_printf("res=%d disk_initialize\n",res);
		msecwait(100);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	} while (res);
	initSPI(1);    /*[h1ijŏ*/
	
	f_mount(DRIVE_NO, &fatfs); /*FATVXẽ}Eg*/

	SCI1_printf("file name = (%s)\n",fname);
	fres=f_open(&fp,fname,FA_CREATE_ALWAYS|FA_WRITE);
	SCI1_printf("res=%d f_open\n",fres);
	f_puts("Hello world.\n",&fp);
	f_puts("This is the line 1.\n",&fp);
	f_puts("This is the line 2.\n",&fp);
	f_puts("This is the line 3.\n",&fp);
	f_puts("This is the last line.\n",&fp);
	fres=f_close(&fp);
	SCI1_printf("res=%d f_close\n",fres);
	
	fres=f_open(&fp,fname,FA_OPEN_EXISTING|FA_READ);
	SCI1_printf("res=%d f_open\n",fres);
	while (f_gets(line_buff,80,&fp)) {
		SCI1_putString(line_buff);
	}
	fres=f_close(&fp);
	SCI1_printf("res=%d f_close\n",fres);
	
	showDirectory("");
	
	f_mount(DRIVE_NO, (FATFS*)0); /*FATVXẽA}Eg*/
	SCI1_printf("completed\n\n");
	while(1);

/*
level 6 long file name
res=0 disk_initialize
file name = (filetest_longname.txt)
res=0 f_open
res=0 f_close
res=0 f_open
Hello world.
This is the line 1.
This is the line 2.
This is the line 3.
This is the last line.
res=0 f_close
res=0 f_getcwd
current directory name : [0:/]
res=0 f_opendir
directory name : []
----A 2011/11/18 09:59        98  filetest.txt
----A 2011/11/21 11:54        14  hello0.txt
D---- 1980/00/00 00:00         0  testdir
----A 1980/00/00 00:00        96  filetest_longname.txt
   3 File(s),       208 bytes
   1 Dir(s),    3946304K bytes free
completed
*/
}
#endif /* #ifdef main6 */


#ifdef main5
/*fBNg̍쐬Ƃ̒ւ̃t@C쐬ƍ폜*/
void main()
{
	int tick=0;
	int res;
	FRESULT fres;
	const char fname[]="filetest.txt";
	const char dirname[]="testdir";

	initLed();
	initTimer1Int(10000); /*10msecC^[o^C}荞*/
	startTimer1();
	initSCI1();
	initSPI_CS();
	msecwait(100); /*SD̂߂ɂ1msecȏwaitKv*/
	initSPI(0);    /*[h0iᑬjŏ*/
	initDMAC();
	set_imask_ccr(0);
	
	SCI1_printf("\nlevel 5 make dir\n");
	do {
		res=disk_initialize(DRIVE_NO);
		SCI1_printf("res=%d disk_initialize\n",res);
		msecwait(100);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	} while (res);
	initSPI(1);    /*[h1ijŏ*/
	
	f_mount(DRIVE_NO, &fatfs); /*FATVXẽ}Eg*/

	showDirectory("");

	fres=f_opendir(&dir,dirname);
	SCI1_printf("res=%d f_opendir %s\n",fres,dirname);
	if (fres) { /*fBNg*/
		fres=f_mkdir(dirname);
		SCI1_printf("res=%d f_mkdir %s\n",fres,dirname);
		if (!fres) { /*쐬ꂽ*/
			fres=f_chdir(dirname);
			SCI1_printf("res=%d f_chdir %s\n",fres,dirname);
			if (!fres) { /*fBNgړ*/
				fres=f_open(&fp,fname,FA_CREATE_ALWAYS|FA_WRITE);
				SCI1_printf("res=%d f_open %s\n",fres,fname);
				f_puts("Hello world.\n",&fp);
				f_puts("This is the line 1.\n",&fp);
				f_puts("This is the line 2.\n",&fp);
				f_puts("This is the line 3.\n",&fp);
				f_puts("This is the last line.\n",&fp);
				fres=f_close(&fp);
				SCI1_printf("res=%d f_close\n",fres);
				showDirectory("");
				fres=f_chdir("..");
				SCI1_printf("res=%d f_chdir ..\n",fres);
			}		
		}
		showDirectory("");
	} else {    /*fBNg*/
		fres=f_chdir(dirname);
		SCI1_printf("res=%d f_chdir %s\n",fres,dirname);
		if (!fres) { /*fBNgړ*/
			fres=f_open(&fp,fname,FA_OPEN_EXISTING|FA_READ);
			SCI1_printf("res=%d f_open %s\n",fres,fname);
			if (!fres) { /*t@CJ*/
				while (f_gets(line_buff,80,&fp)) {
					SCI1_putString(line_buff);
				}
				fres=f_close(&fp);
				SCI1_printf("res=%d f_close\n",fres);
				fres=f_unlink(fname);
				SCI1_printf("res=%d f_unlink %s\n",fres,fname);
			}
			fres=f_chdir("..");
			SCI1_printf("res=%d f_chdir ..\n",fres);
			if (!fres) { /*fBNgړ*/
				if (!showDirectory(dirname)) {
					fres=f_unlink(dirname);
					SCI1_printf("res=%d f_unlink %s\n",fres,dirname);
				}
			}
		}
		showDirectory("");
	}
	f_mount(DRIVE_NO, (FATFS*)0); /*FATVXẽA}Eg*/
	SCI1_printf("completed\n\n");
	while(1);

/*

̃eXgvOł́C[gfBNgɃfBNgutestdirvȂ΁C
fBNgutestdirvC̒Ƀt@Cufiletest.txtvB
CfBNgutestdirv΁C̒̃t@Cufiletest.txtv
\Ct@CCfBNgutestdirvB

level 5 make dir
res=0 disk_initialize
res=0 f_getcwd
current directory name : [0:/]
res=0 f_opendir
directory name : []
----A 1980/00/00 00:00        96  filetest.txt
----A 2011/11/15 15:53        14  hello0.txt
   2 File(s),       110 bytes
   0 Dir(s),    3946400K bytes free
res=5 f_opendir testdir
res=0 f_mkdir testdir
res=0 f_chdir testdir
res=0 f_open filetest.txt
res=0 f_close
res=0 f_getcwd
current directory name : [0:/TESTDIR]
res=0 f_opendir
directory name : []
D---- 1980/00/00 00:00         0  .
D---- 1980/00/00 00:00         0  ..
----A 1980/00/00 00:00        96  filetest.txt
   1 File(s),        96 bytes
   0 Dir(s),    3946336K bytes free
res=0 f_chdir ..
res=0 f_getcwd
current directory name : [0:/]
res=0 f_opendir
directory name : []
----A 1980/00/00 00:00        96  filetest.txt
D---- 1980/00/00 00:00         0  testdir
----A 2011/11/15 15:53        14  hello0.txt
   2 File(s),       110 bytes
   1 Dir(s),    3946336K bytes free
completed

level 5 make dir
res=0 disk_initialize
res=0 f_getcwd
current directory name : [0:/]
res=0 f_opendir
directory name : []
----A 1980/00/00 00:00        96  filetest.txt
D---- 1980/00/00 00:00         0  testdir
----A 2011/11/15 15:53        14  hello0.txt
   2 File(s),       110 bytes
   1 Dir(s),    3946336K bytes free
res=0 f_opendir testdir
res=0 f_chdir testdir
res=0 f_open filetest.txt
Hello world.
This is the line 1.
This is the line 2.
This is the line 3.
This is the last line.
res=0 f_close
res=0 f_unlink filetest.txt
res=0 f_chdir ..
res=0 f_getcwd
current directory name : [0:/]
res=0 f_opendir testdir
directory name : [testdir]
D---- 1980/00/00 00:00         0  .
D---- 1980/00/00 00:00         0  ..
   0 File(s),         0 bytes
   0 Dir(s),    3946368K bytes free
res=0 f_unlink testdir
res=0 f_getcwd
current directory name : [0:/]
res=0 f_opendir
directory name : []
----A 1980/00/00 00:00        96  filetest.txt
----A 2011/11/15 15:53        14  hello0.txt
   2 File(s),       110 bytes
   0 Dir(s),    3946400K bytes free
completed
*/
}
#endif /* #ifdef main5 */


#ifdef main4
/*t@C̏݁Cǂݍ݂ƃfBNg*/
void main()
{
	int tick=0;
	int res;
	FRESULT fres;
	const char fname[]="filetest.txt";

	initLed();
	initTimer1Int(10000); /*10msecC^[o^C}荞*/
	startTimer1();
	initSCI1();
	initSPI_CS();
	msecwait(10); /*SD̂߂ɂ1msecȏwaitKv*/
	initSPI(0);    /*[h0iᑬjŏ*/
	initDMAC();
	set_imask_ccr(0);
	
	SCI1_printf("\nlevel 4 read file\n");
	do {
		res=disk_initialize(DRIVE_NO);
		SCI1_printf("res=%d disk_initialize\n",res);
		msecwait(100);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	} while (res);
	initSPI(1);    /*[h1ijŏ*/
	
	f_mount(DRIVE_NO, &fatfs); /*FATVXẽ}Eg*/

	fres=f_open(&fp,fname,FA_CREATE_ALWAYS|FA_WRITE);
	SCI1_printf("res=%d f_open\n",fres);
	f_puts("Hello world.\n",&fp);
	f_puts("This is the line 1.\n",&fp);
	f_puts("This is the line 2.\n",&fp);
	f_puts("This is the line 3.\n",&fp);
	f_puts("This is the last line.\n",&fp);
	fres=f_close(&fp);
	SCI1_printf("res=%d f_close\n",fres);
	
	fres=f_open(&fp,fname,FA_OPEN_EXISTING|FA_READ);
	SCI1_printf("res=%d f_open\n",fres);
	while (f_gets(line_buff,80,&fp)) {
		SCI1_putString(line_buff);
	}
	fres=f_close(&fp);
	SCI1_printf("res=%d f_close\n",fres);
	
	showDirectory("");
	
	f_mount(DRIVE_NO, (FATFS*)0); /*FATVXẽA}Eg*/
	SCI1_printf("completed\n\n");
	while(1);
/*
level 4 read file
res=0 disk_initialize
res=0 f_open
res=0 f_close
res=0 f_open
Hello world.
This is the line 1.
This is the line 2.
This is the line 3.
This is the last line.
res=0 f_close
res=0 f_opendir
----A 1980/00/00 00:00        96  filetest.txt
----A 2011/11/15 15:53        14  hello0.txt
   2 File(s),       110 bytes
   0 Dir(s),    3946400K bytes free
*/
}
#endif /* #ifdef main4 */


#ifdef main3
/*sector0̎擾*/
void main()
{
	int tick=0;
	int res;
	int i,j;
	int sect_num=0;       /*MBR*/
/*	int sect_num=0x2000;  /*BPB*/
/*	int sect_num=0x3878;  /*FAT*/
/*	int sect_num=0x4000;  /*root directory*/

	initLed();
	initTimer1Int(10000); /*10msecC^[o^C}荞*/
	startTimer1();
	initSCI1();
	initSPI_CS();
	msecwait(10); /*SD̂߂ɂ1msecȏwaitKv*/
	initSPI(0);    /*[h0iᑬjŏ*/
	initDMAC();
	set_imask_ccr(0);
	
	SCI1_printf("\nlevel 3 read sector\n");
	do {
		res=disk_initialize(DRIVE_NO);
		SCI1_printf("res=%d disk_initialize\n",res);
		msecwait(100);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	} while (res);
	initSPI(1);    /*[h1ijŏ*/

	res=disk_read(0,buff,sect_num,1);/*driveNO:0,buff,start sector number, count of sector*/
	SCI1_printf("res=%d disk_read\n",res);
	SCI1_printf("sector number=%d [%x]\n",sect_num,sect_num);
	for (j=0; j<512; j+=16) {
		SCI1_printf("%04x: ",j);
		for (i=0;i<16;i++) SCI1_printf("%02x ",buff[j+i]);
		for (i=0;i<16;i++) {
			if (0x20<buff[j+i] &&buff[j+i]<0x7f) SCI1_printf("%c",buff[j+i]);
			else SCI1_printf(".");
		}
		SCI1_printf("\n");
	}
	SCI1_printf("completed\n\n");
	while(1);
/*
level 3 read sector
res=0 disk_initialize
res=0 disk_read
sector number=0 [0]
0000: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0010: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0020: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0030: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0040: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0050: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0060: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0070: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0080: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0090: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00a0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00b0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00c0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00d0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00e0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00f0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0100: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0110: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0120: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0130: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0140: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0150: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0160: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0170: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0180: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0190: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01a0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01b0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 02 ................
01c0: 03 01 0b 69 e9 d4 00 20 00 00 00 90 78 00 00 00 ...i........x...
01d0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01e0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01f0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 55 aa ..............U.
completed

sector0̓}X^[u[gR[h
typedef struct MasterBootRecode {
    Byte    checkRoutionOnx86[446];
    struct {
        Byte    bootDescriptor;              0x80: bootable device, 0x00: non-bootable
        Byte    firstPartitionSector[3];     1st sector number
        Byte    fileSystemDescriptor;        1:FAT12, 4:FAT16(less than 32MB), 5:g DOS p[eBV,
                                             6:FAT16(more 32MB), 0xb:FAT32(more 2GB),
                                             0xc:FAT32 Int32h g, 0xe:FAT16 Int32h g,
                                             0xf:g DOS p[eBV Int32h g
        Byte    lastPartitionSector[3];
        Byte    firstSectorNumbers[4];       first sector number (link to BPB sector)
        Byte    numberOfSectors[4];
    }   partitionTable[4];
    Byte    sig[2];                         0x55, 0xaa
}   MBRecode;

̎sʂł
1ben܂ĂpartitionTable[0]ɂ
bootDescriptor;           00 non-bootable
firstPartitionSector[3];  02 03 01   010302
fileSystemDescriptor;     0b FAT32(more 2GB)
lastPartitionSector[3];   69 e9 d4   d4e969
firstSectorNumbers[4];    00 20 00 00 00002000
numberOfSectors[4];       00 90 78 00 00789000

level 3 read sector
res=0 disk_initialize
res=0 disk_read
sector number=8192 [2000]
0000: eb 58 90 4d 53 44 4f 53 35 2e 30 00 02 40 78 18 .X.MSDOS5.0..@x.
0010: 02 00 00 00 00 f8 00 00 3f 00 ff 00 00 20 00 00 ........?.......
0020: 00 90 78 00 c4 03 00 00 00 00 00 00 02 00 00 00 ..x.............
0030: 01 00 06 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0040: 80 00 29 5e a3 6e fe 4e 4f 20 4e 41 4d 45 20 20 ..)^.n.NO.NAME..
0050: 20 20 46 41 54 33 32 20 20 20 33 c9 8e d1 bc f4 ..FAT32...3.....
0060: 7b 8e c1 8e d9 bd 00 7c 88 4e 02 8a 56 40 b4 41 {......|.N..V@.A
0070: bb aa 55 cd 13 72 10 81 fb 55 aa 75 0a f6 c1 01 ..U..r...U.u....
0080: 74 05 fe 46 02 eb 2d 8a 56 40 b4 08 cd 13 73 05 t..F..-.V@....s.
0090: b9 ff ff 8a f1 66 0f b6 c6 40 66 0f b6 d1 80 e2 .....f...@f.....
00a0: 3f f7 e2 86 cd c0 ed 06 41 66 0f b7 c9 66 f7 e1 ?.......Af...f..
00b0: 66 89 46 f8 83 7e 16 00 75 38 83 7e 2a 00 77 32 f.F..~..u8.~*.w2
00c0: 66 8b 46 1c 66 83 c0 0c bb 00 80 b9 01 00 e8 2b f.F.f..........+
00d0: 00 e9 2c 03 a0 fa 7d b4 7d 8b f0 ac 84 c0 74 17 ..,...}.}.....t.
00e0: 3c ff 74 09 b4 0e bb 07 00 cd 10 eb ee a0 fb 7d <.t............}
00f0: eb e5 a0 f9 7d eb e0 98 cd 16 cd 19 66 60 80 7e ....}.......f`.~
0100: 02 00 0f 84 20 00 66 6a 00 66 50 06 53 66 68 10 ......fj.fP.Sfh.
0110: 00 01 00 b4 42 8a 56 40 8b f4 cd 13 66 58 66 58 ....B.V@....fXfX
0120: 66 58 66 58 eb 33 66 3b 46 f8 72 03 f9 eb 2a 66 fXfX.3f;F.r...*f
0130: 33 d2 66 0f b7 4e 18 66 f7 f1 fe c2 8a ca 66 8b 3.f..N.f......f.
0140: d0 66 c1 ea 10 f7 76 1a 86 d6 8a 56 40 8a e8 c0 .f....v....V@...
0150: e4 06 0a cc b8 01 02 cd 13 66 61 0f 82 75 ff 81 .........fa..u..
0160: c3 00 02 66 40 49 75 94 c3 42 4f 4f 54 4d 47 52 ...f@Iu..BOOTMGR
0170: 20 20 20 20 00 00 00 00 00 00 00 00 00 00 00 00 ................
0180: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0190: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01a0: 00 00 00 00 00 00 00 00 00 00 00 00 0d 0a 52 65 ..............Re
01b0: 6d 6f 76 65 20 64 69 73 6b 73 20 6f 72 20 6f 74 move.disks.or.ot
01c0: 68 65 72 20 6d 65 64 69 61 2e ff 0d 0a 44 69 73 her.media....Dis
01d0: 6b 20 65 72 72 6f 72 ff 0d 0a 50 72 65 73 73 20 k.error...Press.
01e0: 61 6e 79 20 6b 65 79 20 74 6f 20 72 65 73 74 61 any.key.to.resta
01f0: 72 74 0d 0a 00 00 00 00 00 ac cb d8 00 00 55 aa rt............U.
completed

BIOS parameter block 
Byte    jmpOpeCode[3];         "eb 58 90"
Byte    OEMName[8];            "MSDOS5.0"
Byte    bytesPerSector[2];     "00 02" 200(Hex)=512
Byte    sectorsPerCluster;     "40"
Byte    reservedSectors[2];    "78 18"1878(Hex)
Byte    numberOfFATs;          "02"
Byte    rootEntries[2];        "00 00"
Byte    totalSectors[2];       "00 00"
Byte    mediaDescriptor;       "f8"
Byte    sectorsPerFAT[2];      "00 00" FAT32 always zero: see bigSectorsPerFAT
Byte    sectorsPerTrack[2];    "3f 00"
Byte    heads[2];              "ff 00"
Byte    hiddenSectors[4];      "00 20 00 00"00002000(Hex)
Byte    bigTotalSectors[4];    "00 90 78 00"00789000(Hex)
Byte    bigSectorsPerFAT[4];    sector/FAT for FAT32        "c4 03 00 00"000003c4(Hex)
Byte    extFlags[2];            use index zero (follows)    "00 00"
                                bit 7      0: enable FAT mirroring, 1: disable mirroring
                                bit 0-3    active FAT number (bit 7 is 1)
Byte    FS_Version[2];                                                   "00 00"
Byte    rootDirStrtClus[4];     root directory cluster                   "02 00 00 00"00000002(Hex)
Byte    FSInfoSec[2];           0xffff: no FSINFO, other: FSINFO sector  "01 00"
Byte    bkUpBootSec[2];         0xffff: no back-up, other: back up boot sector number  "06 00"
Byte    reserved[12];           "00 00 00 00 00 00 00 00 00 00 00 00"
Byte    driveNumber;            "80"
Byte    unused;                 "00"
Byte    extBootSignature;       "29"
Byte    serialNumber[4];        "5e a3 6e fe"
Byte    volumeLabel[11];        "4e 4f 20 4e 41 4d 45 20 20 20 20" "NO NAME    "
Byte    fileSystemType[8];      "46 41 54 33 32 20 20 20" "FAT32   "
Byte    loadProgramCode[420];
Byte    sig[2];                 "55 aa"

level 3 read sector
res=0 disk_initialize
res=0 disk_read
sector number=14456 [3878]
0000: f8 ff ff 0f ff ff ff 0f ff ff ff 0f 00 00 00 00 ................
0010: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0020: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0030: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0040: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0050: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0060: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0070: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0080: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0090: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00a0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00b0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00c0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00d0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00e0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
00f0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0100: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0110: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0120: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0130: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0140: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0150: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0160: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0170: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0180: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
0190: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01a0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01b0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01c0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01d0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01e0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
01f0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ................
completed
*/
}
#endif /* #ifdef main3 */


#ifdef main2
/*SDJ[h̎擾*/
void main()
{
	int tick=0;
	int res;
	WORD size_sect;
	DWORD num_sect;
	BYTE type_flag;
	int i;
	
	initLed();
	initTimer1Int(10000); /*10msecC^[o^C}荞*/
	startTimer1();
	initSCI1();
	initSPI_CS();
	msecwait(10); /*SD̂߂ɂ1msecȏwaitKv*/
	initSPI(0);    /*[h0iᑬjŏ*/
	initDMAC();
	set_imask_ccr(0);
	
	SCI1_printf("\nlevel 2\n");
	do {
		res=disk_initialize(DRIVE_NO);
		SCI1_printf("res=%d disk_initialize\n",res);
		msecwait(100);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	} while (res);
	initSPI(1);    /*[h1ijŏ*/
	
	res=disk_ioctl(0,CTRL_SYNC,&size_sect);
	SCI1_printf("res=%d CTRL_SYNC\n",res);
	res=disk_ioctl(0,GET_SECTOR_SIZE,&size_sect);
	SCI1_printf("res=%d size_sect=%d\n",res,size_sect);
	res=disk_ioctl(0,GET_SECTOR_COUNT,&num_sect);
	SCI1_printf("res=%d num_sect=%ld\n",res,num_sect);

	res=disk_ioctl(0,MMC_GET_TYPE,&type_flag);
	SCI1_printf("res=%d type_flag=%d\n",res,type_flag);
	res=disk_ioctl(0,MMC_GET_CSD,&buff);
	SCI1_printf("res=%d CSD\n",res);
	for (i=0;i<16;i++) SCI1_printf("%02x ",buff[i]);
	SCI1_printf("\n");
	res=disk_ioctl(0,MMC_GET_CID,&buff);
	SCI1_printf("res=%d CID\n",res);
	for (i=0;i<16;i++) SCI1_printf("%02x ",buff[i]);
	for (i=0;i<16;i++) {
		if (0x20<buff[i] &&buff[i]<0x7f) SCI1_printf("%c",buff[i]);
		else SCI1_printf(".");
	}
	SCI1_printf("completed\n");
	while(1);

/*
KINGMAX SDHC 4GB ̗

level 2
res=0 disk_initialize
res=0 CTRL_SYNC
res=0 size_sect=512
res=0 num_sect=7909376
res=0 type_flag=12
res=0 CSD
40 0e b0 32 5b 59 00 00 1e 2b 7f 80 0a 40 00 f3
res=0 CID
13 4b 47 53 44 30 34 47 00 00 c8 02 66 00 9c f1 .KGSD04G....f...
completed

܂Ƃ
eʂ́@7909376~512=4049600512bytes 3862Mbytes 4GB𖼏Ă
typéuSD ver 2vŁuBlock addressingv
OEM/Application ID[2]FKG
Product name      [6]FSD04G

*/
}
#endif /* #ifdef main2 */


#ifdef main1
/*`FbN*/
void main()
{
	int tick=0;
	int res;
	unsigned char str[]="666666";

	initLed();
	initTimer1Int(10000); /*10msecC^[o^C}荞*/
	startTimer1();
	initSCI1();
	initSPI_CS();
	msecwait(10); /*SD̂߂ɂ1msecȏwaitKv*/
	initSPI(0);    /*[h0iᑬjŏ*/
	initDMAC();
	set_imask_ccr(0);
	SCI1_printf("\nlevel 1 loop\n");

	do {
		res=disk_initialize(DRIVE_NO);
		SCI1_printf("res=%d disk_initialize\n",res);
		msecwait(100);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	} while (res);
	initSPI(1);    /*[h1ijŏ*/

	while (1) {
		res=disk_initialize(DRIVE_NO);
		SCI1_printf("res=%d disk_initialize\n",res);
		msecwait(20);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	}
}
#endif /* #ifdef main1 */


#ifdef main0
/*Ƃ{Iȃ[v`FbN*/
int checkPushSWreliably(int n)
{
	int k;
	if (!checkPushSW(0)) return 0;
	k=0;
	while (checkPushSW(n)) if (k<30000) k++;
	if (k<10000) return 0;
	return 1;
}

void main()
{
	int tick=0;
	int res;
	int test=0;
	unsigned char str[]="666666aaaa";
	unsigned char str1[10];

	initPushSW();
	init8BitSW();
	initLed();
	initTimer1Int(10000); /*10msecC^[o^C}荞*/
	startTimer1();
	initSCI1();
	initSPI_CS();
	msecwait(10); /*SD̂߂ɂ1msecȏwaitKv*/
	initSPI(0);    /*[h0iᑬjŏ*/
	initDMAC();
	set_imask_ccr(0);
	SCI1_printf("\n level 0   8bitSW:bit0(0:SLOW 1:FAST),  pushSW:bit0(change test)\n");

	while (1) {
		if (check8BitSW(0)) { /*8bitSW̑0rbgON*/
			initSPI(1);    /*[h1ijŏ*/
		} else {
			initSPI(0);    /*[h0iᑬjŏ*/
		}
		if (checkPushSWreliably(0)) test++;
		if (5<test) test=0;
		if (test==0) res=SPI_putData(str,2);
		if (test==1) res=SPI_putData(str,10);
		if (test==2) res=SPI_getData(str1,1);
		if (test==3) res=wait_ready();
		if (test==4) res=send_cmd(0, 0xffL);  /*CMD0+0xff*/
		if (test==5) res=disk_initialize(DRIVE_NO);
		SCI1_printf("test= %02x res=%02x\r",test,res);
		msecwait(20);
		if (tick=1-tick) turnOnLed(0);
		else turnOffLed(0); 
	}
}
#endif /* #ifdef main0 */
