#include <machine.h>
#include <3048fone.h>
#include "ff.h"
#include "diskio.h"
#include "spi.h"


/*  p SCI0SPIʐMɎgƂ AKI-H8 szu
MMC_DI SCI0TXD(P9-b0) CN1-25
MMC_DO SCI0RXD(P9-b2) CN1-27
MMC_CK SCI0SCK(P9-b4) CN1-29
MMC_CS   CS(P4-b3)   CN1- 34
*/

/*  p P4bitSPIʐMɎgƂ AKI-H8 szu
MMC_DO RXD(P4-b0) CN1- 31
MMC_CK CK (P4-b1) CN1- 32
MMC_DI TXD(P4-b2) CN1- 33
MMC_CS CS (P4-b3) CN1- 34
*/

/*ŏ100kbps`400kbpsǂƂĂ̂*/
/*#define SLOW_BRR 199   /*=25MHz31.25kbps */
/*#define SLOW_BRR  99   /*=25MHz 62.5kbps */
#define SLOW_BRR  49   /*=25MHz  125kbps */
#define FAST_BRR   0   /*=25MHz 6250kbps */

#define SCIIDLPORT P9
#define DDR_VALUE_SCIIDLPORT 0x11    /*00010001*/
#define DR_VALUE_SCIIDLPORT 0x11     /*00010001*/


extern char P4DDR;

#define PORTforMMC P4
#define PORTDDRforMMC P4DDR
#define DDR_VALUE_BIT 0xe   /*00001110*/
#define DDR_VALUE_SCI 8     /*00001000*/

#define MMC_DO PORTforMMC.DR.BIT.B0 /*CPU猩RXD*/
#define MMC_CK PORTforMMC.DR.BIT.B1
#define MMC_DI PORTforMMC.DR.BIT.B2 /*CPU猩TXD*/
#define MMC_CS PORTforMMC.DR.BIT.B3

/* H8n[hEFA       */
/* mode 0 ᑬ[h  */
/* mode 1 [h  */
#ifdef _BIT_GEN
static BYTE trans_mode=0;
#endif

void initSPI(int mode)
{
#ifndef _BIT_GEN
	int i,dummy,brr;
	
	brr = mode? FAST_BRR : SLOW_BRR;
	SCIforSPI.SCR.BYTE = 0x00;    /* SCK[q͓Clocko */
	SCIforSPI.SSR.BYTE = 0x80;    /* G[tONA 10000000 */
	SCIforSPI.SMR.BYTE = 0x80;    /* Clock[hC=25MHz */
	SCIforSPI.BRR = brr;          /*@baud rate̐ݒ@*/
	for (i=0; i<(brr+1)*10; i++); /* 1bit(160ns)ȏ҂ */
	INTC.IPRB.BIT._SCI0=1;                  /*SCI0̊荞݂Dɂ*/
	
	SCIIDLPORT.DDR=DDR_VALUE_SCIIDLPORT;
	SCIIDLPORT.DR.BYTE=DR_VALUE_SCIIDLPORT;
#else
	trans_mode=mode;
#endif
}

void initSPI_CS(void)
{
#ifdef _BIT_GEN
	/*PORTforMMC.DDR = DDR_VALUE_BIT;*/
	PORTDDRforMMC |= DDR_VALUE_BIT;
	PORTforMMC.DDR = PORTDDRforMMC;
	MMC_CS = 1;
	MMC_DI = 1;
	MMC_CK = 1;
#else
	/*PORTforMMC.DDR = DDR_VALUE_SCI;*/
	PORTDDRforMMC |= DDR_VALUE_SCI;
	PORTforMMC.DDR = PORTDDRforMMC;
	MMC_CS = 1;
#endif
}

void initDMAC(void)
{
	INTC.IPRB.BIT._DMAC=1;                  /*DMAC̊荞݂Dɂ*/
}

/*1byte̒lbittɂ*/
static unsigned char reverseBit8(unsigned char x)
{
	x=(x<<4)|(x>>4);
	x=((x&0x33)<<2)|((x&0xcc)>>2);
	x=((x&0x55)<<1)|((x&0xaa)>>1);
	return x;
}

#ifdef _BIT_GEN   /************************************/
#define DELAY_COUNT 14
typedef union {
	unsigned char BYTE;               /*  Byte Access */
	struct {                          /*  Bit  Access */
		unsigned char B7:1;           /*    Bit 7     */
		unsigned char B6:1;           /*    Bit 6     */
		unsigned char B5:1;           /*    Bit 5     */
		unsigned char B4:1;           /*    Bit 4     */
		unsigned char B3:1;           /*    Bit 3     */
		unsigned char B2:1;           /*    Bit 2     */
		unsigned char B1:1;           /*    Bit 1     */
		unsigned char B0:1;           /*    Bit 0     */
	}  BIT;                           /*              */
} unibyte_t;

int SPI_delay(void)
{
	int j;
	for (j=0;j<DELAY_COUNT;j++);
	return j;
}

/* SPI (SCI) datanum bytes o*/
/*߂lFMoCg*/
int SPI_putData(unsigned char *data, int num)
{
	unibyte_t tmp;
	int i;
	if (trans_mode) {
		for (i=0;i<num;i++) {
			tmp.BYTE=*data++;
			MMC_CK = 0;
			MMC_DI = tmp.BIT.B7;
			MMC_CK = 1; MMC_CK = 0;
			MMC_DI = tmp.BIT.B6;
			MMC_CK = 1; MMC_CK = 0;
			MMC_DI = tmp.BIT.B5;
			MMC_CK = 1; MMC_CK = 0;
			MMC_DI = tmp.BIT.B4;
			MMC_CK = 1; MMC_CK = 0;
			MMC_DI = tmp.BIT.B3;
			MMC_CK = 1; MMC_CK = 0;
			MMC_DI = tmp.BIT.B2;
			MMC_CK = 1; MMC_CK = 0;
			MMC_DI = tmp.BIT.B1;
			MMC_CK = 1; MMC_CK = 0;
			MMC_DI = tmp.BIT.B0;
			MMC_CK = 1;
		}
	} else {
		for (i=0;i<num;i++) {
			tmp.BYTE=*data++;
			MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B7;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B6;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B5;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B4;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B3;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B2;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B1;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			MMC_DI = tmp.BIT.B0;
			MMC_CK = 1; SPI_delay();
		}
	}
}

/* SPI (SCI) datanum bytes */
/*߂lFMoCg*/
int SPI_getData(unsigned char *data, int num)
{
	int i;
	BYTE r;
	if (trans_mode) {
		for (i=0;i<num;i++) {
			MMC_DI = 1;
			MMC_CK = 0;
			r = 0;   if (MMC_DO) r++;
			MMC_CK = 1; MMC_CK = 0;
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; MMC_CK = 0;
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; MMC_CK = 0;
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; MMC_CK = 0;
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; MMC_CK = 0;
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; MMC_CK = 0;
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; MMC_CK = 0;
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1;
			*data++=r;
		}
	} else {
		int j;
		for (i=0;i<num;i++) {
			MMC_DI = 1;
			MMC_CK = 0; SPI_delay();
			r = 0;   if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay(); MMC_CK = 0; SPI_delay();
			r <<= 1; if (MMC_DO) r++;
			MMC_CK = 1; SPI_delay();
			*data++=r;
		}
	}
}
#endif /*#ifdef _BIT_GEN ******************************/

#ifdef _SPI_POLLING   /************************************/
/* SPI (SCI) datanum bytes o*/
/*߂lFMoCg*/
/*int SPI_putDataPolling(unsigned char *data, int num)*/
int SPI_putData(unsigned char *data, int num)
{
	int i;
	SCIforSPI.SCR.BIT.TE=1;       /*M*/
	for (i=0; i<num; i++,data++) {
		while (!SCIforSPI.SSR.BIT.TDRE); /*TDRE==0Ȃ҂*/
		SCIforSPI.TDR = reverseBit8(*data);
		SCIforSPI.SSR.BIT.TDRE = 0; /*clear flag*/
	}
	while(!SCIforSPI.SSR.BIT.TEND);
	SCIforSPI.SCR.BIT.TE=0;       /*M֎~*/
	return i;
}

/* SPI (SCI) datanum bytes */
/*߂lFMoCg*/
/*int SPI_getDataPolling(unsigned char *data, int num)*/
int SPI_getData(unsigned char *data, int num)
{
	int i;
	SCIforSPI.SCR.BIT.TE=1;       /*M*/
	while (!SCIforSPI.SSR.BIT.TDRE); /*TDRE==0Ȃ҂*/
	SCIforSPI.SCR.BIT.TE=0;       /*M֎~*/
	for (i=0; i<num; i++,data++) {
		if (SCIforSPI.SSR.BIT.ORER) SCIforSPI.SSR.BIT.ORER=0;
		SCIforSPI.SSR.BIT.RDRF=0;
		SCIforSPI.SCR.BYTE=0x30;       /*M TE,RE𓯎1ɂȂ΂ȂȂ*/
		SCIforSPI.TDR = 0xff;
		SCIforSPI.SSR.BIT.TDRE = 0; /*clear flag*/
		while (!SCIforSPI.SSR.BIT.RDRF);
		SCIforSPI.SCR.BYTE=0;         /*M֎~*/
		SCIforSPI.SSR.BIT.RDRF=0;
		*data=reverseBit8(SCIforSPI.RDR);
	}
	return i;
}
#endif /*#ifdef _SPI_POLLING ***************************/


#ifdef _SPI_DMA   /************************************/
/* SPI (SCI) DMApdatanum bytes o*/
/*int SPI_putDataDMA(unsigned char *data, int num)*/
int SPI_putData(unsigned char *data, int num)
{
	int i;

	for (i=0;i<num;i++) data[i]=reverseBit8(data[i]);

	DMAC0A.MAR = data;                          /* M */
	DMAC0A.IOAR = (BYTE)(&(SCIforSPI.TDR));     /* M */
	DMAC0A.ETCR = num;                          /* ] */
	while(DMAC0A.DTCR.BIT.DTE) DMAC0A.DTCR.BIT.DTE=0;  /* DTE=0̏Ԃ̓ǂݍ*/
	DMAC0A.DTCR.BYTE = 0x4;                     /* IO[hCSCI0̑Mf[^empty荞݂ŋN */

	DMAC0A.DTCR.BIT.DTE = 1;                    /* ] */
	DMAC0A.DTCR.BIT.DTIE = 1;                   /* ]I荞݋*/

	SCIforSPI.SCR.BYTE = 0xa0;    /* M SCIM荞݋ SCK[q͓Clocko */
	
	while (DMAC0A.DTCR.BIT.DTE);                /* DMAC0A.DTCR.BIT.DTE0ɂȂ]I */

	while(!SCIforSPI.SSR.BIT.TEND);
	/*KvȃNbNoĂ~܂悤ɂ*/
	SCIforSPI.SCR.BYTE = 0x00;    /* M֎~ SCIM荞݋֎~ SCK[q͓Clocko */
	for (i=0;i<num;i++) data[i]=reverseBit8(data[i]); /*̍s̓eXgpBۂɂ͂Ȃ*/

	return num;
}

/* SPI (SCI) datanum bytes */
/*߂lFMoCg*/
/*int SPI_getDataDMA(unsigned char *data, int num)*/
int SPI_getData(unsigned char *data, int num)
{
	int i;
	const char dummy=0xff;

	DMAC0A.MAR = &dummy;                        /* M */
	DMAC0A.IOAR = (BYTE)(&(SCIforSPI.TDR));     /* M */
	DMAC0A.ETCR = num;                          /* ] */
	DMAC0B.MAR = data;                          /* M */
	DMAC0B.IOAR = (BYTE)(&(SCIforSPI.RDR));     /* M */
	DMAC0B.ETCR = num;                          /* ] */

	while(DMAC0A.DTCR.BIT.DTE) DMAC0A.DTCR.BIT.DTE=0;  /* DTE=0̏Ԃ̓ǂݍ*/
	DMAC0A.DTCR.BYTE = 0x14;                    /* ACh[hCSCI0̑Mf[^empty荞݂ŋN */
	while (DMAC0B.DTCR.BIT.DTE) DMAC0B.DTCR.BIT.DTE=0; /* DTE0ɂȂ */
	DMAC0B.DTCR.BYTE = 0x05;                    /* I/O[hCSCI0̎Mf[^full荞݂ŋN */

	DMAC0A.DTCR.BIT.DTE = 1;                    /* ] */
	DMAC0A.DTCR.BIT.DTIE = 1;                   /* ]I荞݋ ACh[hłDTEIɃNAȂ*/
	DMAC0B.DTCR.BIT.DTE = 1;                    /* ] */

	SCIforSPI.SSR.BYTE &= 0x87;                 /* ORER FER PE RDRF ̃NA*/
	SCIforSPI.SCR.BYTE = 0xf0;    /* M SCIM荞݋ SCK[q͓Clocko */

	while (DMAC0A.DTCR.BIT.DTE);                /* DMAC0A.DTCR.BIT.DTE0ɂȂ]I */

	while(!SCIforSPI.SSR.BIT.TEND);
	/*KvȃNbNoĂ~܂悤ɂ*/
	SCIforSPI.SCR.BYTE = 0x00;    /* M֎~ SCIM荞݋֎~ SCK[q͓Clocko */

	for (i=0;i<num;i++) data[i]=reverseBit8(data[i]);
	return num;
}
#endif /*#ifdef _SPI_DMA **********************************/

void SPI_assertCS() {MMC_CS = 0;}      /* MMC CS = L */
void SPI_negateCS() {MMC_CS = 1;}      /* MMC CS = H */


/** timer service for SD timeout **/

static volatile BYTE DownCounter[2]={0, 0};	/* 100Hz Down Counter */

/* SPI_TimerWork should be called every 10msec from an Interval Timer Interrupt */
void SPI_TimerWork(void)
{
	/*
	static int t=0;
	if (++t&0x40) turnOnLed(1);
	else turnOffLed(1);
	*/
	if (DownCounter[0]) DownCounter[0]--;
	if (DownCounter[1]) DownCounter[1]--;
}

/* Setting initial value to the Down Counter on the centi second time scale */
void SPI_setDownCounter(unsigned char chan, unsigned char csec)
{
	DownCounter[chan]=csec;
}

unsigned char SPI_getDownCounter(unsigned char chan)
{
	return DownCounter[chan];
}
